=== debian/changelog ===
intel-compute-runtime (22.39.24347-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 04 Oct 2022 16:53:29 +0300

intel-compute-runtime (22.34.24023-2) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Add salsa-ci.yml.

  [ Timo Aaltonen ]
  * control: Bump build-dep on igc.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 20 Sep 2022 15:36:21 +0300

intel-compute-runtime (22.34.24023-1) unstable; urgency=medium

  * New upstream release.
  * control: Drop i386, it's not supported anymore.
  * typos.patch: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 26 Aug 2022 13:53:36 +0300

intel-compute-runtime (22.31.23852-1) unstable; urgency=medium

  * New upstream release.  (Closes: #1016951)
  * patches: Drop correct-getters-in-generated-commands.diff (upstream),
    refresh typos.patch.
  * control: Bump i-g-c build-depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 15 Aug 2022 19:01:19 +0300

intel-compute-runtime (22.14.22890-2) unstable; urgency=medium

  * Merge changes from 21.32.20609-3.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 18 Jun 2022 03:46:24 +0200

intel-compute-runtime (21.32.20609-3) unstable; urgency=medium

  * control, rules: Tighten dependencies on the igc version used at build
    time. Tighten dependencies on the llvm version used to build igc.
  * Manually activate the ldconfig trigger for unversioned libocloc.so.
  * Enable all hardening flags.
  * control: Bump policy to 4.6.1.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 22 May 2022 14:47:21 +0200
